Unit MainForm;

Interface

Uses
  Winapi.Windows, Winapi.Messages, System.SysUtils,
  System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ComCtrls,
  HashTable, Vcl.Menus, VTreeDriver, Vcl.StdCtrls,
  Vcl.ExtCtrls, Vcl.CheckLst, LogSettings;

Type
  TDeviceNodeType = (dntLower, dntCurrent, dntUpper);

  TForm1 = Class (TForm)
    DriverDeviceTreeView: TTreeView;
    PageControl1: TPageControl;
    DeviceTabSheet: TTabSheet;
    DriverTabSheet: TTabSheet;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Createsnapshot1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    DriverDevicesListView: TListView;
    MajorFunctionListview: TListView;
    Panel1: TPanel;
    DriverAddressLEdit: TLabeledEdit;
    DriverNameLEdit: TLabeledEdit;
    Panel2: TPanel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    GroupBox3: TGroupBox;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    CheckBox9: TCheckBox;
    CheckBox10: TCheckBox;
    GroupBox4: TGroupBox;
    CheckBox11: TCheckBox;
    CheckBox12: TCheckBox;
    CheckBox13: TCheckBox;
    CheckBox14: TCheckBox;
    CheckBox15: TCheckBox;
    CheckBox16: TCheckBox;
    CheckBox17: TCheckBox;
    CheckBox18: TCheckBox;
    CheckBox19: TCheckBox;
    CheckBox20: TCheckBox;
    CheckBox21: TCheckBox;
    CheckBox22: TCheckBox;
    GroupBox5: TGroupBox;
    DevicePnpListView: TListView;
    CheckBox23: TCheckBox;
    CheckBox24: TCheckBox;
    CheckBox25: TCheckBox;
    CheckBox26: TCheckBox;
    CheckBox27: TCheckBox;
    CheckBox28: TCheckBox;
    CheckBox29: TCheckBox;
    CheckBox30: TCheckBox;
    CheckBox31: TCheckBox;
    CheckBox32: TCheckBox;
    Edit8: TEdit;
    Label8: TLabel;
    Createlog1: TMenuItem;
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    LabeledEdit3: TLabeledEdit;
    LabeledEdit4: TLabeledEdit;
    LabeledEdit5: TLabeledEdit;
    LabeledEdit6: TLabeledEdit;
    LabeledEdit7: TLabeledEdit;
    est1: TMenuItem;
    SaveDialog1: TSaveDialog;
    TabSheet1: TTabSheet;
    GroupBox6: TGroupBox;
    GroupBox7: TGroupBox;
    GroupBox8: TGroupBox;
    LogIncludeDriversChL: TCheckListBox;
    LogDriverSettingsChL: TCheckListBox;
    LogDeviceSettingsChL: TCheckListBox;
    Panel3: TPanel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Panel4: TPanel;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Panel5: TPanel;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Panel6: TPanel;
    GroupBox9: TGroupBox;
    CheckBox33: TCheckBox;
    CheckBox34: TCheckBox;
    GroupBox10: TGroupBox;
    CheckBox36: TCheckBox;
    CheckBox37: TCheckBox;
    CheckBox38: TCheckBox;
    CheckBox39: TCheckBox;
    CheckBox40: TCheckBox;
    CheckBox41: TCheckBox;
    CheckBox42: TCheckBox;
    CheckBox35: TCheckBox;
    Procedure FormCreate(Sender: TObject);
    Procedure FormClose(Sender: TObject; var Action: TCloseAction);
    Procedure Exit1Click(Sender: TObject);
    Procedure Createsnapshot1Click(Sender: TObject);
    Procedure DriverDeviceTreeViewChange(Sender: TObject; Node: TTreeNode);
    Procedure est1Click(Sender: TObject);
    Procedure Button1Click(Sender: TObject);
    Procedure LogDriverSettingsChLClickCheck(Sender: TObject);
  Private
    FDriverAddresses : TList;
    FDriverNames : TStringList;
    FDriverTable : TAddressHashTable;
    FDeviceTable : TAddressHashTable;
    FLogSettings : TLogSettings;
    FSnapshot : PSnapshot;
    Procedure CreateSnapshot;
    Procedure DestroySnapshot;
    Procedure FreeDeviceRecord(ARecord:Pointer);
    Procedure FreeDriverRecord(ARecord:Pointer);
    Function CreateDriverNode(ADriverRecord:PDriverSnapshot):TTreeNode;
    Function CreateDeviceNode(ADeviceRecord:PDeviceSnapshot; AParent:TTreeNode; ANodeType:TDeviceNodeType):TTreeNode;
    Function CreateDeviceNodes(ADeviceRecord:PDeviceSnapshot; AParent:TTreeNode):TTreeNode;
    Procedure DisplaySnapshot;
    Procedure DisplayDriverInfo(ADriverRecord:PDriverSnapshot);
    Procedure displayDeviceInfo(ADeviceRecord:PDeviceSnapshot);

    Function CopyString(AStart:Pointer; AOffset:Cardinal):WideString;

    Procedure GenerateDriverRecordLog(ARecord:PDriverSnapshot; ALog:TStringList);
    Procedure GenerateDeviceRecordLog(ARecord:PDeviceSnapshot; ALog:TStringList);
    Procedure GenerateOSVersionInfo(ALog:TStringList);
    Procedure GenerateVTHeader(ALog:TStringList);
    Procedure LogSettingsFromGUI;


    Procedure CheckListBoxInvert(AChL:TCheckListBox);
  end;

Var
  Form1: TForm1;

Implementation

{$R *.DFM}

Uses
  Kernel, Utils;

Procedure TForm1.CheckListBoxInvert(AChL:TCheckListBox);
Var
  I : Integer;
begin
For I := 0 To AChL.Count - 1 Do
  AChL.Checked[I] := Not AChL.Checked[I];

LogDriverSettingsChLClickCheck(AChL);
end;

Procedure TForm1.Button1Click(Sender: TObject);
Var
  I : Integer;
begin
If Sender = Button1 Then
  LogIncludeDriversChL.CheckAll(cbChecked)
Else If Sender = Button2 Then
  LogIncludeDriversChL.CheckAll(cbUnchecked)
Else If Sender = Button3 Then
  CheckListBoxInvert(LogIncludeDriversChL)
Else If Sender = Button4 Then
  LogDriverSettingsChL.CheckAll(cbChecked)
Else If Sender = Button5 Then
  LogDriverSettingsChL.CheckAll(cbUnchecked)
Else If Sender = Button6 Then
  CheckListBoxInvert(LogDriverSettingsChL)
Else If Sender = Button7 Then
  LogDeviceSettingsChL.CheckAll(cbChecked)
Else If Sender = Button8 Then
  LogDeviceSettingsChL.CheckAll(cbUnchecked)
Else If Sender = Button9 Then
  CheckListBoxInvert(LogDeviceSettingsChL);
end;

Function TForm1.CopyString(AStart:Pointer; AOffset:Cardinal):WideString;
Var
  W : PWChar;
begin
W := PWChar(NativeInt(AStart) + AOffset);
Result := Copy(WideString(W), 1, Strlen(W));
end;

Procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
DestroySnapshot;
FLogSettings.Free;
FDriverNames.Free;
FDriverAddresses.Free;
FDeviceTable.Free;
FDriverTable.Free;
end;

Procedure TForm1.FormCreate(Sender: TObject);
Var
  I : Integer;
begin
FDriverTable := TAddressHashTable.Create(251, FreeDriverRecord);
FDeviceTable := TAddressHashTable.Create(255, FreeDeviceRecord);
For I := 0 To IRP_MJ_MAXIMUM_FUNCTION Do
  begin
  With MajorFunctionListView.Items.Add Do
    begin
    Caption := IrpMajorToStr(I);
    SubItems.Add('');
    end;
  end;

LogDriverSettingsChL.CheckAll(cbChecked);
LogDeviceSettingsChL.CheckAll(cbChecked);

FDriverAddresses := TList.Create;
FDriverNames := TStringList.Create;
FLogSettings := TLogSettings.Create(FDriverTable, FDeviceTable);
Createsnapshot1Click(CreateSnapshot1);
end;

Procedure TForm1.FreeDeviceRecord(ARecord:Pointer);
Var
  R : PDeviceSnapshot;
begin
R := ARecord;
SetLength(R.LowerDevices, 0);
SetLength(R.UpperDevices, 0);
Dispose(R);
end;

Procedure TForm1.FreeDriverRecord(ARecord:Pointer);
Var
  R : PDriverSnapshot;
begin
R := ARecord;
SetLength(R.Devices, 0);
Dispose(R);
end;

Procedure TForm1.DestroySnapshot;
begin
FDriverTable.Clear;
FDeviceTable.Clear;
If Assigned(FSnapshot) Then
  begin
  SetLength(FSnapshot.Drivers, 0);
  Dispose(FSnapshot);
  FSnapshot := Nil;
  end;
end;

Procedure TForm1.Exit1Click(Sender: TObject);
begin
Close;
end;

Procedure TForm1.CreateSnapshot;
Var
  Snapshot : Pointer;
  DriverRecord : PDriverSnapshot;
  DeviceRecord : PDeviceSnapshot;

  Index : Integer;

  Ret : Boolean;
  DriverList : PSNAPSHOT_DRIVERLIST;
  DriverInfo : PSNAPSHOT_DRIVERINFO;
  DeviceInfo : PSNAPSHOT_DEVICEINFO;
  DriverInfoHandle : PPointer;
  DeviceInfoHandle : PPointer;
  I, J, K : Integer;
  pDevice : PPointer;
begin
FDriverAddresses.Clear;
FDriverNames.Clear;
Ret := GetDeviceDriverList(FDriverAddresses, FDriverNames);
If Ret Then
  begin
  Ret := DriverCreateSnapshot(Snapshot);
  If Ret Then
    begin
    DriverList := Snapshot;
    New(FSnapshot);
    FSnapshot.NumberOfDrivers := DriverList.NumberOfDrivers;
    SetLength(FSnapshot.Drivers, FSnapshot.NumberOfDrivers);
    DriverInfoHandle := PPointer(NativeInt(DriverList) + DriverList.DriversOffset);
    For I := 0 To DriverList.NumberOfDrivers - 1 Do
      begin
      DriverInfo := DriverInfoHandle^;
      FSnapshot.Drivers[I] := DriverInfo.ObjectAddress;

      New(DriverRecord);
      DriverRecord.Address := DriverInfo.ObjectAddress;
      DriverRecord.Name := CopyString(DriverInfo, DriverInfo.NameOffset);
      DriverRecord.MajorFunction := DriverInfo.MajorFunction;
      DriverRecord.NumberOfDevices := DriverInfo.NumberOfDevices;
      DriverRecord.ImageBase := DriverInfo.ImageBase;
      DriverRecord.ImageSize := DriverInfo.ImageSize;
      DriverRecord.DriverEntry := DriverInfo.DriverEntry;
      DriverRecord.DriverUnload := DriverInfo.DriverUnload;
      DriverRecord.Flags := DriverInfo.Flags;
      DriverRecord.StartIo := DriverInfo.StartIo;
      DriverRecord.ImagePath := '';
      Index := FDriverAddresses.IndexOf(DriverRecord.ImageBase);
      If Index > -1 Then
        DriverRecord.ImagePath := FDriverNames[Index];

      SetLength(DriverRecord.Devices, DriverRecord.NumberOfDevices);
      DeviceInfoHandle := PPointer(NativeInt(DriverInfo) + DriverInfo.DevicesOffset);
      For J := 0 To DriverRecord.NumberOfDevices - 1 Do
        begin
        DeviceInfo := DeviceInfoHandle^;
        DriverRecord.Devices[J] := DeviceInfo.ObjectAddress;

        New(DeviceRecord);
        DeviceRecord.Address := DeviceInfo.ObjectAddress;
        DeviceRecord.Name := CopyString(DeviceInfo, DeviceInfo.NameOffset);
        DeviceRecord.DriverName := DriverRecord.Name;
        DeviceRecord.DriverAddress := DriverRecord.Address;
        DeviceRecord.DisplayName := CopyString(DeviceInfo, DeviceInfo.DisplayNameOffset);
        DeviceRecord.Description := CopyString(DeviceInfo, DeviceInfo.DescriptionOffset);
        DeviceRecord.Vendor := CopyString(DeviceInfo, DeviceInfo.VendorNameOffset);
        DeviceRecord.Location := CopyString(DeviceInfo, DeviceInfo.LocationOffset);
        DeviceRecord.ClassName := CopyString(DeviceInfo, DeviceInfo.ClassNameOffset);
        DeviceRecord.Enumerator := CopyString(DeviceInfo, DeviceInfo.EnumeratorOffset);
        DeviceRecord.ClassGuid := CopyString(deviceInfo, DeviceInfo.ClassGuidOffset);
        DeviceRecord.Flags := DeviceInfo.Flags;
        DeviceRecord.Characteristics := DeviceInfo.Characteristics;
        DeviceRecord.DeviceType := DeviceInfo.DeviceType;
        DeviceRecord.DiskDeviceAddress := DeviceInfo.DiskDevice;
        DeviceRecord.NumberOfLowerDevices := DeviceInfo.NumberOfLowerDevices;
        DeviceRecord.NumberOfUpperDevices := DeviceInfo.NumberOfUpperDevices;
        SetLength(DeviceRecord.LowerDevices, DeviceRecord.NumberOfLowerDevices);
        SetLength(DeviceRecord.UpperDevices, DeviceRecord.NumberOfUpperDevices);
        pDevice := PPointer(NativeInt(DeviceInfo) + DeviceInfo.LowerDevicesOffset);
        For K := 0 To DeviceRecord.NumberOfLowerDevices - 1 Do
          begin
          DeviceRecord.LowerDevices[K] := pDevice^;
          Inc(pDevice);
          end;

        pDevice := PPointer(NativeInt(DeviceInfo) + DeviceInfo.UpperDevicesOffset);
        For K := 0 To DeviceRecord.NumberOfUpperDevices - 1 Do
          begin
          DeviceRecord.UpperDevices[K] := pDevice^;
          Inc(pDevice);
          end;

        FDeviceTable.Insert(DeviceRecord.Address, DeviceRecord);
        Inc(DeviceInfoHandle);
        end;

      FDriverTable.Insert(DriverRecord.Address, DriverRecord);
      Inc(DriverInfoHandle);
      end;

    DriverFreeSnapshot(Snapshot);
    end;
  end;
end;

Procedure TForm1.Createsnapshot1Click(Sender: TObject);
begin
DriverDeviceTreeView.Items.Clear;
DestroySnapshot;
CreateSnapshot;
DisplaySnapshot;
end;

Function TForm1.CreateDeviceNode(ADeviceRecord:PDeviceSnapshot; AParent:TTreeNode; ANodeType:TDeviceNodeType):TTreeNode;
Var
  DeviceName : WideString;
begin
If ADeviceRecord.Name <> '' Then
  DeviceName := Format('%s (0x%p) - %s', [ADeviceRecord.Name, ADeviceRecord.Address, ADeviceRecord.DriverName])
Else DeviceName := Format('<unnamed> (0x%p) - %s', [ADeviceRecord.Address, ADeviceRecord.DriverName]);

Case ANodeType Of
  dntUpper : DeviceName := 'UPP: ' + DeviceName;
  dntLower : DeviceName := 'LOW: ' + DeviceName;
  end;

Result := DriverDeviceTreeView.Items.AddChild(AParent, DeviceName);
Result.Data := ADeviceRecord;
end;

Function TForm1.CreateDeviceNodes(ADeviceRecord:PDeviceSnapshot; AParent:TTreeNode):TTreeNode;
Var
  I : Integer;
  DevNode : PDeviceSnapshot;
begin
For I := ADeviceRecord.NumberOfLowerDevices - 1 DownTo 0 Do
  begin
  DevNode := FDeviceTable.Get(ADeviceRecord.LowerDevices[I]);
  If Assigned(DevNode) Then
    AParent := CreateDeviceNode(DevNode, AParent, dntLower)
  Else AParent := DriverDeviceTreeView.Items.AddChild(AParent, Format('LOW: <unknown> (0x%p)', [ADeviceRecord.LowerDevices[I]]));
  end;

AParent := CreateDeviceNode(ADeviceRecord, AParent, dntCurrent);
For I := ADeviceRecord.NumberOfUpperDevices - 1 Downto 0 Do
  begin
  DevNode := FDeviceTable.Get(ADeviceRecord.UpperDevices[I]);
  If Assigned(DevNode) Then
    AParent := CreateDeviceNode(DevNode, AParent, dntUpper)
  Else AParent := DriverDeviceTreeView.Items.AddChild(AParent, Format('UPP: <unknown> (0x%p)', [ADeviceRecord.UpperDevices[I]]));
  end;
end;

Function TForm1.CreateDriverNode(ADriverRecord:PDriverSnapshot):TTreeNode;
Var
  I : Integer;
  DevRecord : PDeviceSnapshot;
begin
Result := DriverDeviceTreeView.Items.AddChild(Nil, ADriverRecord.Name);
Result.Data := ADriverRecord;
For I := 0 To ADriverRecord.NumberOfDevices - 1 Do
  begin
  DevRecord := FDeviceTable.Get(ADriverRecord.Devices[I]);
  If Assigned(DevRecord) Then
    CreateDeviceNodes(DevRecord, Result)
  Else begin
    With DriverDeviceTreeView.Items.AddChild(Result, Format('<unknown> (0x%p)', [ADriverRecord.Devices[I]])) Do
      Data := Nil;
    end;
  end;
end;

Procedure TForm1.DisplaySnapshot;
Var
  I : Integer;
  DriverRecord : PDriverSnapshot;
begin
DriverDeviceTreeView.SortType := stNone;
For I := 0 To FSnapshot.NumberOfDrivers - 1 Do
  begin
  DriverRecord := FDriverTable.Get(FSnapshot.Drivers[I]);
  If Assigned(DriverRecord) Then
    CreateDriverNode(DriverRecord)
  Else begin
    With DriverDeviceTreeView.Items.AddChild(Nil, Format('<unknown> (0x%p)', [FSnapshot.Drivers[I]])) Do
      Data := Nil;
    end;
  end;

DriverDeviceTreeView.SortType := stText;
LogIncludeDriversChL.Clear;
For I := 0 To FSnapshot.NumberOfDrivers - 1 Do
  begin
  DriverRecord := FDriverTable.Get(FSnapshot.Drivers[I]);
  If Assigned(DriverRecord) Then
    LogIncludeDriversChL.Items.AddObject(Format('%s (0x%p)', [DriverRecord.Name, DriverRecord.Address]), FSnapshot.Drivers[I])
  Else LogIncludeDriversChL.Items.AddObject(Format('<unknown> (0x%p)', [FSnapshot.Drivers[I]]), FSnapshot.Drivers[I]);
  LogIncludeDriversChL.Checked[I] := True;
  end;
end;


Procedure TForm1.DriverDeviceTreeViewChange(Sender: TObject; Node: TTreeNode);
begin
DriverTabSheet.TabVisible := (Node.Selected) And (Not Assigned(Node.Parent));
DeviceTabSheet.TabVisible := (Node.Selected) And (Assigned(Node.Parent));
If Node.Selected Then
  begin
  If DriverTabSheet.TabVisible Then
    PageControl1.ActivePage := DriverTabSheet
  Else If DeviceTabSheet.TabVisible Then
    PageControl1.ActivePage := DeviceTabSheet;

  If Assigned(Node.Parent) Then
    begin
    If Assigned(Node.Data) Then
      DisplayDeviceInfo(Node.Data);
    end
  Else If Assigned(Node.Data) Then
         DisplayDriverInfo(Node.Data);
  end;
end;

Procedure TForm1.est1Click(Sender: TObject);
Var
  tmp : PDeviceSnapshot;
  DR : PDriverSnapshot;
  I, J : Integer;
  Log : TStringList;
begin
If SaveDialog1.Execute Then
  begin
  LogSettingsFromGUI;
  Log := TStringList.Create;
  If FLogSettings.General.IncludeVTHeader Then
    GenerateVTHeader(Log);

  If FLogSettings.General.IncludeOSVersion Then
    GenerateOSVersionInfo(Log);

  For I := 0 To FSnapshot.NumberOfDrivers - 1 Do
    begin
    DR := FDriverTable.Get(FSnapshot.Drivers[I]);
    If (Assigned(DR)) And (FLoGSettings.DriverIncluded(DR.Address)) Then
      begin
      GenerateDriverRecordLog(DR, Log);
      If FLogSettings.DriverSettings.IncludeDevices Then
        begin
        For J := 0 To DR.NumberOfDevices - 1 Do
          begin
          tmp := FDeviceTable.Get(DR.Devices[J]);
          If Assigned(tmp) Then
            GenerateDeviceRecordLog(tmp, Log)
          Else Log.Add(Format('      <unknown device> (0x%p)', [DR.Devices[J]]));
          end;
        end;
      end;
    end;

  Log.SaveToFile(SaveDialog1.FileName);
  Log.Free;
  end;
end;

Procedure TForm1.DisplayDriverInfo(ADriverRecord:PDriverSnapshot);
Var
  I : Integer;
  DevNode : PDeviceSnapshot;
  DeviceName : WideString;
begin
DriverAddressLEdit.Text := Format('0x%p', [ADriverRecord.Address]);
DriverNameLEdit.Text := ADriverRecord.Name;
For I := 0 To IRP_MJ_MAXIMUM_FUNCTION Do
  MajorFunctionListview.Items[I].SubItems[0] := Format('0x%p', [ADriverRecord.MajorFunction[I]]);

DriverDevicesListView.Items.BeginUpdate;
DriverDevicesListView.Clear;
For I := 0 To ADriverRecord.NumberOfDevices - 1 Do
  begin
  DevNode := FDeviceTable.Get(ADriverRecord.Devices[I]);
  If Assigned(DevNode) Then
    DeviceName := DevNode.Name
  Else DeviceName := '<unknown>';

  With DriverDevicesListView.Items.Add Do
    begin
    Caption := DeviceName;
    SubItems.Add(Format('0x%p', [ADriverRecord.Devices[I]]));
    Data := DevNode;
    end;
  end;

DriverDevicesListView.Items.EndUpdate;
LabeledEdit1.Text := Format('0x%p', [ADriverRecord.ImageBase]);
LabeledEdit2.Text := Format('%d', [ADriverRecord.ImageSize]);
LabeledEdit3.Text := Format('0x%p', [ADriverRecord.DriverEntry]);
LabeledEdit4.Text := Format('0x%p', [ADriverRecord.DriverUnload]);
LabeledEdit5.Text := ADriverRecord.ImagePath;
LabeledEdit6.Text := Format('0x%p', [ADriverRecord.StartIo]);
LabeledEdit7.Text := Format('0x%x', [ADriverRecord.Flags]);

CheckBox35.Checked := (ADriverRecord.Flags And DRVO_UNLOAD_INVOKED) > 0;
CheckBox36.Checked := (ADriverRecord.Flags And DRVO_LEGACY_DRIVER) > 0;
CheckBox37.Checked := (ADriverRecord.Flags And DRVO_BUILTIN_DRIVER) > 0;
CheckBox38.Checked := (ADriverRecord.Flags And DRVO_REINIT_REGISTERED) > 0;
CheckBox39.Checked := (ADriverRecord.Flags And DRVO_INITIALIZED) > 0;
CheckBox40.Checked := (ADriverRecord.Flags And DRVO_BOOTREINIT_REGISTERED) > 0;
CheckBox41.Checked := (ADriverRecord.Flags And DRVO_LEGACY_RESOURCES) > 0;
CheckBox42.Checked := (ADriverRecord.Flags And DRVO_BASE_FILESYSTEM_DRIVER) > 0;
end;

Procedure TForm1.DisplayDeviceInfo(ADeviceRecord:PDeviceSnapshot);
Var
  DiskDevNode : PDeviceSnapshot;
  DiskDevName : WideString;
begin
Edit1.Text := Format('0x%p', [ADeviceRecord.Address]);
Edit2.Text := ADeviceRecord.Name;
Edit3.Text := Format('0x%p', [ADeviceRecord.DriverAddress]);
Edit4.Text := ADeviceRecord.DriverName;
Edit5.Text := Format('%d', [ADeviceRecord.DeviceType]);
Edit6.Text := Format('0x%x', [ADeviceRecord.Flags]);
Edit7.Text := Format('0x%x', [ADeviceRecord.Characteristics]);
If Assigned(ADeviceRecord.DiskDeviceAddress) Then
  begin
  DiskDevNode := FDeviceTable.Get(ADeviceRecord.DiskDeviceAddress);
  If Assigned(DiskDevNode) Then
    DiskDevName := Format('%S (0x%p)', [DiskDevNode.Name, ADeviceRecord.DiskDeviceAddress])
  Else DiskDevName := Format('<unknown> (0x%p)', [ADeviceRecord.DiskDeviceAddress]);
  end
Else DiskDevName:= Format('<none> (0x%p)', [Nil]);

Edit8.Text := DiskDevName;

CheckBox1.Checked := (ADeviceRecord.Flags And DO_BUFFERED_IO) <> 0;
CheckBox2.Checked := (ADeviceRecord.Flags And DO_DIRECT_IO) <> 0;
CheckBox3.Checked := (ADeviceRecord.Flags And DO_BUS_ENUMERATED_DEVICE) <> 0;
CheckBox4.Checked := (ADeviceRecord.Flags And DO_DEVICE_INITIALIZING) <> 0;
CheckBox5.Checked := (ADeviceRecord.Flags And DO_EXCLUSIVE) <> 0;
CheckBox6.Checked := (ADeviceRecord.Flags And DO_MAP_IO_BUFFER) <> 0;
CheckBox7.Checked := (ADeviceRecord.Flags And DO_POWER_INRUSH) <> 0;
CheckBox8.Checked := (ADeviceRecord.Flags And DO_POWER_PAGABLE) <> 0;
CheckBox9.Checked := (ADeviceRecord.Flags And DO_SHUTDOWN_REGISTERED) <> 0;
CheckBox10.Checked := (ADeviceRecord.Flags And DO_VERIFY_VOLUME) <> 0;
CheckBox23.Checked := (ADeviceRecord.Flags And DO_DEVICE_HAS_NAME) <> 0;
CheckBox24.Checked := (ADeviceRecord.Flags And DO_SYSTEM_BOOT_PARTITION) <> 0;
CheckBox25.Checked := (ADeviceRecord.Flags And DO_LONG_TERM_REQUESTS) <> 0;
CheckBox26.Checked := (ADeviceRecord.Flags And DO_NEVER_LAST_DEVICE) <> 0;
CheckBox27.Checked := (ADeviceRecord.Flags And DO_LOW_PRIORITY_FILESYSTEM) <> 0;
CheckBox28.Checked := (ADeviceRecord.Flags And DO_SUPPORTS_TRANSACTIONS) <> 0;
CheckBox29.Checked := (ADeviceRecord.Flags And DO_FORCE_NEITHER_IO) <> 0;
CheckBox30.Checked := (ADeviceRecord.Flags And DO_VOLUME_DEVICE_OBJECT) <> 0;
CheckBox31.Checked := (ADeviceRecord.Flags And DO_SYSTEM_SYSTEM_PARTITION) <> 0;
CheckBox32.Checked := (ADeviceRecord.Flags And DO_SYSTEM_CRITICAL_PARTITION) <> 0;

CheckBox11.Checked := (ADeviceRecord.Characteristics And FILE_AUTOGENERATED_DEVICE_NAME) <> 0;
CheckBox12.Checked := (ADeviceRecord.Characteristics And FILE_CHARACTERISTIC_PNP_DEVICE) <> 0;
CheckBox13.Checked := (ADeviceRecord.Characteristics And FILE_CHARACTERISTIC_TS_DEVICE) <> 0;
CheckBox14.Checked := (ADeviceRecord.Characteristics And FILE_CHARACTERISTIC_WEBDAV_DEVICE) <> 0;
CheckBox15.Checked := (ADeviceRecord.Characteristics And FILE_DEVICE_IS_MOUNTED) <> 0;
CheckBox16.Checked := (ADeviceRecord.Characteristics And FILE_DEVICE_SECURE_OPEN) <> 0;
CheckBox17.Checked := (ADeviceRecord.Characteristics And FILE_FLOPPY_DISKETTE) <> 0;
CheckBox18.Checked := (ADeviceRecord.Characteristics And FILE_READ_ONLY_DEVICE) <> 0;
CheckBox19.Checked := (ADeviceRecord.Characteristics And FILE_REMOTE_DEVICE) <> 0;
CheckBox20.Checked := (ADeviceRecord.Characteristics And FILE_REMOVABLE_MEDIA) <> 0;
CheckBox21.Checked := (ADeviceRecord.Characteristics And FILE_VIRTUAL_VOLUME) <> 0;
CheckBox22.Checked := (ADeviceRecord.Characteristics And FILE_WRITE_ONCE_MEDIA) <> 0;

With DevicePnpListView Do
  begin
  Items[0].SubItems[0] := ADeviceRecord.DisplayName;
  Items[1].SubItems[0] := ADeviceRecord.Description;
  Items[2].SubItems[0] := ADeviceRecord.Vendor;
  Items[3].SubItems[0] := ADeviceRecord.ClassName;
  Items[4].SubItems[0] := ADeviceRecord.ClassGuid;
  Items[5].SubItems[0] := ADeviceRecord.Location;
  Items[6].SubItems[0] := ADeviceRecord.Enumerator;
  end;
end;

Procedure TForm1.GenerateDriverRecordLog(ARecord:PDriverSnapshot; ALog:TStringList);
Var
  I : Integer;
  DL : TDriverLogSettings;
begin
DL := FLogSettings.DriverSettings;
ALog.Add(Format('DRIVER %s (0x%p)', [ARecord.Name, ARecord.Address]));
If DL.IncludeFileName Then
  ALog.Add(Format('  Filename:           %s', [ARecord.ImagePath]));

If DL.IncludeImageBase Then
  ALog.Add(Format('  Image base address: 0x%p', [ARecord.ImageBase]));

If DL.IncludeImageSize Then
  ALog.Add(Format('  Image size:         %d', [ARecord.ImageSize]));

If DL.IncludeDriverEntry Then
  ALog.Add(Format('  DriverEntry:        0x%p', [ARecord.DriverEntry]));

If DL.IncludeDriverUnload Then
  ALog.Add(Format('  DriverUnload:       0x%p', [ARecord.DriverUnload]));

If DL.IncludeStartIo Then
  ALog.Add(Format('  StartIo:            0x%p', [ARecord.StartIo]));

If DL.IncludeFlags Then
  begin
  If DL.IncludeFlagsStr Then
    ALog.Add(Format('  Flags:              0x%x (%s)', [ARecord.Flags, DriverFlagsToStr(ARecord.Flags)]))
  Else ALog.Add(Format('  Flags:              0x%x', [ARecord.Flags]));
  end;

If DL.IncludeMajorFunctions Then
  begin
  ALog.Add('  MajorFunction');
  For I := 0 To 28 Do
    ALog.Add(Format('    %s: 0x%p', [IrpMajorToStr(I), ARecord.MajorFunction[I]]));
  end;

If DL.IncludeNumberOfDevices Then
  ALog.Add(Format('  Number of devices:  %d', [ARecord.NumberOfDevices]));
end;

Procedure TForm1.GenerateDeviceRecordLog(ARecord:PDeviceSnapshot; ALog:TStringList);
Var
  I : Integer;
  tmp : PDeviceSnapshot;
  tmpStr : WideString;
  DL : TDeviceLogSettings;
begin
DL := FLogSettings.DeviceSettings;
ALog.Add(Format('    DEVICE %s (0x%p)', [ARecord.Name, ARecord.Address]));
If DL.IncludeType Then
  ALog.Add(Format('      Type:            0x%x', [ARecord.DeviceType]));

If DL.IncludeFlags Then
  begin
  If DL.IncludeFlagsStr Then
    ALog.Add(Format('      Flags:           0x%x (%s)', [ARecord.Flags, DeviceFlagsToStr(ARecord.Flags)]))
  Else ALog.Add(Format('      Flags:           0x%x', [ARecord.Flags]));
  end;

If DL.IncludeCharacteristics Then
  begin
  If DL.IncludeCharacteristicsStr Then
    ALog.Add(Format('      Characteristics: 0x%x (%s)', [ARecord.Characteristics, DeviceCharacteristicsToStr(ARecord.Characteristics)]))
  Else ALog.Add(Format('      Characteristics: 0x%x', [ARecord.Characteristics]));
  end;

If DL.IncludePnPInformation Then
  begin
  If ((ARecord.Flags And DO_BUS_ENUMERATED_DEVICE) <> 0) Then
    begin
    If DL.IncludeFriendlyName Then
      ALog.Add(Format('      Friendly name:     %s', [ARecord.DisplayName]));

    If DL.IncludeDescription Then
      ALog.Add(Format('      Description:     %s', [ARecord.Description]));

    If DL.IncludeVendor Then
      ALog.Add(Format('      Manufacturer:    %s', [ARecord.Vendor]));

    If DL.IncludeEnumerator Then
      ALog.Add(Format('      Enumerator:      %s', [ARecord.Enumerator]));

    If DL.IncludeLocation Then
      ALog.Add(Format('      Location:        %s', [ARecord.Location]));

    If DL.IncludeClass Then
      begin
      If DL.IncludeClassGuid Then
        ALog.Add(Format('      Class:           %s (%s)', [ARecord.ClassName, ARecord.ClassGuid]))
      Else ALog.Add(Format('      Class:           %s', [ARecord.ClassName]));
      end;
    end;
  end;

If DL.IncludeDiskDevice Then
  begin
  tmp := FDeviceTable.Get(ARecord.DiskDeviceAddress);
  If Assigned(tmp) Then
    ALog.Add(Format('      Disk device:     %s (0x%p) (%s)', [tmp.Name, tmp.Address, tmp.DriverName]));
  end;

If DL.IncludeLowerDevicesCount Then
  ALog.Add(Format('      Number of lower Devices: %d', [ARecord.NumberOfLowerDevices]));

If (DL.IncludeLowerDevices) And (ARecord.NumberOfLowerDevices > 0) Then
  begin
  ALog.Add('      Lower devices:');
  For I := 0 To ARecord.NumberOfLowerDevices - 1 Do
    begin
    tmp := FDeviceTable.Get(ARecord.LowerDevices[I]);
    If Assigned(tmp) Then
      ALog.Add(Format('        %s (0x%p) (%s)', [tmp.Name, tmp.Address, tmp.DriverName]))
    Else ALog.Add(Format('        <unknown> (0x%p)', [ARecord.LowerDevices[I]]));
    end;
  end;

If DL.IncludeUpperDevicesCount Then
  ALog.Add(Format('      Number of upper Devices: %d', [ARecord.NumberOfUpperDevices]));

If (DL.IncludeUpperDevices) And
   (ARecord.NumberOfUpperDevices > 0) Then
  begin
  ALog.Add('      Upper devices:');
  For I := 0 To ARecord.NumberOfUpperDevices - 1 Do
    begin
    tmp := FDeviceTable.Get(ARecord.UpperDevices[I]);
    If Assigned(tmp) Then
      ALog.Add(Format('        %s (0x%p) (%s)', [tmp.Name, tmp.Address, tmp.DriverName]))
    Else ALog.Add(Format('        <unknown> (0x%p)', [ARecord.UpperDevices[I]]));
    end;
  end;
end;

Procedure TForm1.LogDriverSettingsChLClickCheck(Sender: TObject);
Var
  I : Integer;
begin
If Sender = LogDriverSettingsChL Then
  begin
  If Not LogDriverSettingsChL.Checked[6] Then
    LogDriverSettingsChL.Checked[7] := False;
  end
Else If Sender = LogDeviceSettingsChL Then
  begin
  If Not LogDeviceSettingsChL.Checked[6] Then
    LogDeviceSettingsChL.Checked[7] := False;

  If Not LogDeviceSettingsChL.Checked[8] Then
    LogDeviceSettingsChL.Checked[9] := False;

  If Not LogDeviceSettingsChL.Checked[10] Then
    begin
    For I := 11 To 17 Do
      LogDeviceSettingsChL.Checked[I] := False;
    end;
  end;
end;

Procedure TForm1.LogSettingsFromGUI;
Var
  I : Integer;
begin
FLogSettings.General.IncludeVTHeader := CheckBox33.Checked;
FLogSettings.General.IncludeOSVersion := CheckBox34.Checked;

FLogSettings.Clear;
For I := 0 To LogIncludeDriversChL.Count - 1 Do
  FLogSettings.IncludeDriver(LogIncludeDriversChL.Items.Objects[I]);

FLogSettings.DriverSettings.IncludeFileName := LogDriverSettingsChl.Checked[0];
FLogSettings.DriverSettings.IncludeImageBase := LogDriverSettingsChl.Checked[1];
FLogSettings.DriverSettings.IncludeImageSize := LogDriverSettingsChl.Checked[2];
FLogSettings.DriverSettings.IncludeDriverEntry := LogDriverSettingsChl.Checked[3];
FLogSettings.DriverSettings.IncludeDriverUnload := LogDriverSettingsChl.Checked[4];
FLogSettings.DriverSettings.IncludeStartIo := LogDriverSettingsChl.Checked[5];
FLogSettings.DriverSettings.IncludeFlags := LogDriverSettingsChl.Checked[6];
FLogSettings.DriverSettings.IncludeFlagsStr := LogDriverSettingsChl.Checked[7];
FLogSettings.DriverSettings.IncludeMajorFunctions := LogDriverSettingsChl.Checked[8];
FLogSettings.DriverSettings.IncludeNumberOfDevices := LogDriverSettingsChl.Checked[9];
FLogSettings.DriverSettings.IncludeDevices := LogDriverSettingsChl.Checked[10];

FLogSettings.DeviceSettings.IncludeType := LogDeviceSettingsChL.Checked[0];
FLogSettings.DeviceSettings.IncludeDiskDevice := LogDeviceSettingsChL.Checked[1];
FLogSettings.DeviceSettings.IncludeUpperDevicesCount := LogDeviceSettingsChL.Checked[2];
FLogSettings.DeviceSettings.IncludeUpperDevices := LogDeviceSettingsChL.Checked[3];
FLogSettings.DeviceSettings.IncludeLowerDevicesCount := LogDeviceSettingsChL.Checked[4];
FLogSettings.DeviceSettings.IncludeLowerDevices := LogDeviceSettingsChL.Checked[5];
FLogSettings.DeviceSettings.IncludeFlags := LogDeviceSettingsChL.Checked[6];
FLogSettings.DeviceSettings.IncludeFlagsStr := LogDeviceSettingsChL.Checked[7];
FLogSettings.DeviceSettings.IncludeCharacteristics := LogDeviceSettingsChL.Checked[8];
FLogSettings.DeviceSettings.IncludeCharacteristicsStr := LogDeviceSettingsChL.Checked[9];
FLogSettings.DeviceSettings.IncludePnPInformation := LogDeviceSettingsChL.Checked[10];
FLogSettings.DeviceSettings.IncludeFriendlyName := LogDeviceSettingsChL.Checked[11];
FLogSettings.DeviceSettings.IncludeDescription := LogDeviceSettingsChL.Checked[12];
FLogSettings.DeviceSettings.IncludeVendor := LogDeviceSettingsChL.Checked[13];
FLogSettings.DeviceSettings.IncludeEnumerator := LogDeviceSettingsChL.Checked[14];
FLogSettings.DeviceSettings.IncludeLocation := LogDeviceSettingsChL.Checked[15];
FLogSettings.DeviceSettings.IncludeClass := LogDeviceSettingsChL.Checked[16];
FLogSettings.DeviceSettings.IncludeClassGuid := LogDeviceSettingsChL.Checked[17];
end;

Procedure TForm1.GenerateOSVersionInfo(ALog:TStringList);
Var
  info : OSVERSIONINFOEXW;
begin
info.dwOSVersionInfoSize := SizeOf(info);
If GetVersionEx(info) Then
  begin
  ALog.Add(Format('OS major version: %d', [info.dwMajorVersion]));
  ALog.Add(Format('OS minor version: %d', [info.dwMinorVersion]));
  ALog.Add(Format('OS build number:  %d', [info.dwBuildNumber]));
  end;

ALog.Add('');
end;

Procedure TForm1.GenerateVTHeader(ALog:TStringList);
begin
ALog.Add('VrtuleTree v1.0');
ALog.Add('Created by Martin Drab, 2013');
ALog.Add(Format('Run from: %s', [Application.ExeName]));
ALog.Add('');
end;

End.

