Unit Utils;

Interface

Uses
  Windows, Classes;

Function GetDeviceDriverList(Addresses:TList; Names:TStringList):Boolean;

Implementation

Uses
  PSAPI, SysUtils;

Function GetDeviceDriverList(Addresses:TList; Names:TStringList):Boolean;
Var
  I : Integer;
  DriverArraySize : Cardinal;
  Needed : Cardinal;
  DriverArray : PPointer;
  DriverAddress : Pointer;
  DriverName : PWideChar;
  DriverNameLen : Cardinal;
  DriverNameStr : WideString;
begin
Needed := 2048;
DriverArraySize := 1024;
DriverArray := Nil;
DriverNameLen := 32768* SizeOf(WideChar);
DriverName := HeapAlloc(GetProcessHeap, HEAP_ZERO_MEMORY, DriverNameLen);
Result := Assigned(DriverName);
If Result Then
  begin
  While Needed > DriverArraySize Do
    begin
    If Assigned(DriverArray) Then
      HeapFree(GetProcessHeap, 0, DriverArray);

    Inc(DriverArraySize, DriverArraySize);
    DriverArray := HeapAlloc(GetProcessHeap, HEAP_ZERO_MEMORY, DriverArraySize);
    Result := Assigned(DriverArray);
    If Result Then
      Result := EnumDeviceDrivers(DriverArray, DriverArraySize, Needed);

    If Not Result Then
      Break;
    end;

  If Result Then
    begin
    Needed := Needed Div SizeOf(Pointer);
    For I := 0 To Needed - 1 Do
      begin
      DriverAddress := PPointer(NativeUInt(DriverArray) + I*SizeOf(Pointer))^;
      DriverNameStr := '<unknown>';
      Result := GetDeviceDriverFileNameW(DriverAddress, DriverName, DriverNameLen) > 0;
      If Result Then
        DriverNameStr := Copy(WideString(DriverName), 1, StrLen(DriverName));

      Addresses.Add(DriverAddress);
      Names.Add(DriverNameStr);
      Result := True;
      end;

    HeapFree(GetProcessHeap, 0, DriverArray);
    end;

  HeapFree(GetProcessHeap, 0, DriverName);
  end;
end;


End.
