
#ifndef __UTILS_DYM_ARRAY_H_
#define __UTILS_DYM_ARRAY_H_

#include <ntifs.h>


#define DYM_ARRAY_INITIAL_ALLOC_LENGTH         16
#define DYM_ARRAY_INCREASE_PER_CENTS           20

typedef struct {
   POOL_TYPE PoolType;
   SIZE_T ValidLength;
   SIZE_T AllocatedLength;
   PFAST_MUTEX LockPaged;
   PKSPIN_LOCK LockNonPaged;
   PVOID *Data;
} UTILS_DYM_ARRAY, *PUTILS_DYM_ARRAY;


NTSTATUS DymArrayCreate(POOL_TYPE PoolType, PUTILS_DYM_ARRAY *Array);
VOID DymArrayDestroy(PUTILS_DYM_ARRAY Array);
NTSTATUS DymArrayReserve(PUTILS_DYM_ARRAY Array, SIZE_T Length);
NTSTATUS DymArrayPushBack(PUTILS_DYM_ARRAY Array, PVOID Value);
PVOID DymArrayPopBack(PUTILS_DYM_ARRAY Array);
NTSTATUS DymArrayPushFront(PUTILS_DYM_ARRAY Array, PVOID Value);
PVOID DymArrayPopFront(PUTILS_DYM_ARRAY Array);
SIZE_T DymArrayLength(PUTILS_DYM_ARRAY Array);
SIZE_T DymArrayAllocatedLength(PUTILS_DYM_ARRAY Array);
PVOID DymArrayItem(PUTILS_DYM_ARRAY Array, SIZE_T Index);
VOID DymArrayLock(PUTILS_DYM_ARRAY Array, PKIRQL Irql);
VOID DymArrayUnlock(PUTILS_DYM_ARRAY Array, KIRQL Irql);
VOID DymArrayToStaticArray(PUTILS_DYM_ARRAY Array, PVOID StaticArray);
NTSTATUS DymArrayToStaticArrayAlloc(PUTILS_DYM_ARRAY Array, POOL_TYPE PoolType, PVOID *StaticArray);


#endif
