
#ifndef __UTILS_MEMORY_H_
#define __UTILS_MEMORY_H_

#include <ntifs.h>

#define PROJECT_POOL_TAG             (ULONG)'ertV'





PVOID HeapMemoryAlloc(POOL_TYPE PoolType, SIZE_T NumberOfBytes);
VOID HeapMemoryFree(PVOID Address);
PVOID HeapMemoryAllocNonPaged(SIZE_T NumberOfBytes);
PVOID HeapMemoryAllocPaged(SIZE_T NumberOfBytes);

NTSTATUS VirtualMemoryAllocUser(SIZE_T NumberOfBytes, ULONG Protection, PVOID *Address);
VOID VirtualMemoryFreeUser(PVOID Address);

NTSTATUS MemoryCopyToUser(PVOID Destionation, PVOID Source, SIZE_T NumberOfBytes);
NTSTATUS MemoryCopyToKernel(PVOID Destionation, PVOID Source, SIZE_T NumberOfBytes);
NTSTATUS MemoryCopyInUser(PVOID Destination, PVOID Source, SIZE_T NumberOfBytes);
NTSTATUS MemoryCopySafe(PVOID Destination, PVOID Source, SIZE_T NumberOfBytes);

NTSTATUS MemoryPointerCopyToUser(PVOID *Destination, PVOID Source);
NTSTATUS MemoryPointerCopyToKernel(PVOID *Destination, PVOID *Source);
NTSTATUS MemoryPointerCopyInUser(PVOID *Destination, PVOID *Source);
NTSTATUS MemoryPointerCopySafe(PVOID *Destination, PVOID *Source);

#endif
