
#ifndef __UTILS_STACK_H_
#define __UTILS_STACK_H_


#include <ntifs.h>


typedef struct _UTILS_STACK_ITEM {
   struct _UTILS_STACK_ITEM *Next;
   PVOID Value;
} UTILS_STACK_ITEM, *PUTILS_STACK_ITEM;

typedef struct {
   PUTILS_STACK_ITEM Top;
   POOL_TYPE PoolType;
} UTILS_STACK, *PUTILS_STACK;


NTSTATUS StackCreate(POOL_TYPE PoolType, PUTILS_STACK *Stack);
VOID StackPushNoAlloc(PUTILS_STACK Stack, PUTILS_STACK_ITEM Item);
NTSTATUS StackPush(PUTILS_STACK Stack, PVOID Value);
PVOID StackPop(PUTILS_STACK Stack);
PUTILS_STACK_ITEM StackPopNoFree(PUTILS_STACK Stack);
BOOLEAN StackEmpty(PUTILS_STACK Stack);
VOID StackDestroy(PUTILS_STACK Stack);

#endif
