
#ifndef __UTILS_STACKED_MEMORY_H_
#define __UTILS_STACKED_MEMORY_H_

#include <ntifs.h>
#include "utils-stack.h"


typedef enum {
   smatHeap,
   smatVirtual
} EStackedMemoryAllocType;


typedef struct {
   UTILS_STACK_ITEM StackItem;
   EStackedMemoryAllocType AllocType;
   PVOID Address;
} UTILS_STACKED_MEMORY_RECORD, *PUTILS_STACKED_MEMORY_RECORD;



NTSTATUS StackedMemoryCreate(POOL_TYPE PoolType, PUTILS_STACK *StackedMemory);
NTSTATUS StackedMemoryHeapAlloc(PUTILS_STACK StackedMemory, POOL_TYPE PoolType, SIZE_T NumberOfBytes, PVOID *Address);
NTSTATUS StackedMemoryHeapAllocPaged(PUTILS_STACK StackedMemory, SIZE_T NumberOfBytes, PVOID *Address);
NTSTATUS StackedMemoryHeapAllocNonPaged(PUTILS_STACK StackedMemory, SIZE_T NumberOfBytes, PVOID *Address);
NTSTATUS StackedMemoryVirtualAllocUser(PUTILS_STACK StackedMemory, SIZE_T NumberOfBytes, ULONG Protection, PVOID *Address);
VOID StackedMemoryLastFree(PUTILS_STACK StackedMemory);
VOID StackedMemoryAllFree(PUTILS_STACK StackedMemory);
VOID StackedMemoryDestroy(PUTILS_STACK StackedMemory);




#endif
